-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

-- state to be persistent between reloads and to be sent to gui / set from GUI
M.state = {}

local function loadshortcutList()
	if FS:fileExists("mods/Shortcuts_list_(torsions-mainmenu-mod).json") then
		return load("mods/Shortcuts_list_(torsions-mainmenu-mod).json")
	else
		return load("torsion/Shortcuts_list_(torsions-mainmenu-mod).json")
	end

end

-- read file into memory
local function load(fn)
    if not json then json = require("json") end
    local content = readFile(fn)
    if content ~= nil then
        local state, data = pcall(json.decode, content)
        if state == true then
			log('A', "torsion-listloader", "test-dump: "..tostring(data))
			data.delay = nil
            return data
        end
    end

    return false
end

local function loadDelay(fn)
    if not json then json = require("json") end
    local content = readFile(fn)
    if content ~= nil then
        local state, data = pcall(json.decode, content)
        if state == true then
			log('A', "torsion-listloader", "test-dump: "..data.delay)
            return data.delay
        end
    end

    return false
end



-- public interface
M.load = load
M.loadshortcutList = loadshortcutList
M.loadDelay = loadDelay

return M
